--Made By Daniel Kluss(xerox_irs@lvcm.com)
--uses new (as of august 12, 2003) modified (by me) asm.e written by (pete or mic)
--must use pentium class or above to read the time stamp of the cpu.
without warning
include machine.e
include asm.e
include misc.e

atom start_cpu_time,start_clock_time,cpu_speed,clock_mult
global constant HLT=get_asm("hlt ret")--don't use this in dos, only in windows dosbox

constant
        CPU_MEM=allocate(8),
        Read_Time_Stamp_Asm = get_asm(sprintf("pusha rdtsc mov [%d],eax mov [%d], edx popa ret",{CPU_MEM,CPU_MEM+4}))

global procedure cpu_hlt()
--wait for interrupt, either keystroke, mouse, harddrive, or realtime clock or other?
--the realtime clock is the only regular interrupt, so the maximum wait is 0.054 seconds
--thats tick_rate(0)=18.2~18.5, if you set it to tick_rate(1000) then maximum wait is 0.001 seconds
--don't use this in dos cause it just crashes, just in windows dosbox, 
--use this to give control back to windows
--you can shorten the wait time by setting the tick_rate higher
        call(HLT)
end procedure

global function cpu_time()--get the clock count, most accurate timer on the computer
        call(Read_Time_Stamp_Asm)
        return peek4u(CPU_MEM)+peek4u(CPU_MEM+4)*#100000000
end function

global function get_cpu_speed()
        return cpu_speed
end function

if platform()=DOS32 then
        tick_rate(1000)--set extremely high timer resolution
end if

start_cpu_time=cpu_time()
start_clock_time=time()
sleep(1)
cpu_speed=(cpu_time()-start_cpu_time)/(time()-start_clock_time)
clock_mult=1/cpu_speed

if platform()=DOS32 then
        tick_rate(0)--set back, cause you don't need it anymore
end if


global function time()--over ride time routine with better one
        return start_clock_time+(cpu_time()-start_cpu_time)*clock_mult
end function

--printf(1,"CPU Speed %8.3f Mhz\n",{get_cpu_speed()/1000000})

